/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20111123-64 [Nov 26 2011]
 * Copyright (c) 2000 - 2011 Intel Corporation
 * 
 * Disassembly of ssdt2.dat, Mon Jan  9 08:13:56 2012
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001F1D (7965)
 *     Revision         0x01
 *     Checksum         0xA2
 *     OEM ID           "OptRef"
 *     OEM Table ID     "OptTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */

DefinitionBlock ("ssdt2.aml", "SSDT", 1, "OptRef", "OptTabl", 0x00001000)
{
    External (DBG8)
    External (ALFP)
    External (DPCM)
    External (DPBM)
    External (P8XH, MethodObj)    // 5 Arguments
    External (DID8)
    External (DID7)
    External (DID6)
    External (NXD8)
    External (NXD7)
    External (NXD6)
    External (NXD5)
    External (NXD4)
    External (NXD3)
    External (NXD2)
    External (NXD1)
    External (NVGA, MethodObj)    // 1 Arguments
    External (DID5, IntObj)
    External (DID4, IntObj)
    External (DID3, IntObj)
    External (DID2, IntObj)
    External (DID1, IntObj)
    External (\PSTE)
    External (\_PR_.P003)
    External (\_PR_.P002)
    External (\_PR_.P001)
    External (\_PR_.P000)
    External (\_SB_.PCI0, DeviceObj)
    External (\_PR_.CPU3._PPC)
    External (\_PR_.CPU2._PPC)
    External (\_PR_.CPU1._PPC)
    External (\_PR_.P000._PSS, IntObj)
    External (\_SB_.PCI0.P0P1, DeviceObj)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.P0P1.PEGP, DeviceObj)
    External (\_SB_.PCI0.SBRG.EC0_.GPWR, IntObj)
    External (\_SB_.PCI0.P0P1.PEGP._ADR)

    Scope (\_SB.PCI0)
    {
        Name (VEN, "VENACPI 2009-Nov-23 14:56:05")
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_INI, 0, NotSerialized)
        {
            Store (DID1, Index (TLPK, Zero))
            Store (DID2, Index (TLPK, 0x02))
            Store (DID3, Index (TLPK, 0x04))
            Store (DID4, Index (TLPK, 0x06))
            Store (DID5, Index (TLPK, 0x08))
            Store (DID2, Index (TLPK, 0x0A))
            Store (DID1, Index (TLPK, 0x0B))
            Store (DID2, Index (TLPK, 0x0D))
            Store (DID3, Index (TLPK, 0x0E))
            Store (DID2, Index (TLPK, 0x10))
            Store (DID4, Index (TLPK, 0x11))
            Store (DID2, Index (TLPK, 0x13))
            Store (DID5, Index (TLPK, 0x14))
        }

        OperationRegion (NVIG, SystemMemory, NVGA (0x0400), Field (NVIG, AnyAcc, NoLock, Preserve)
            {
                NISG,   128, 
                NISZ,   32, 
                NIVR,   32, 
                GPSS,   32, 
                GACD,   16, 
                GATD,   16, 
                LDES,   8, 
                DKST,   8, 
                DACE,   8, 
                DHPE,   8, 
                DHPS,   8, 
                HGNC,   8, 
                GPPO,   8, 
                USPM,   8, 
                GPSP,   8, 
                TLSN,   8, 
                DOSF,   8
            })
        Name (TLPK, Package (0x16)
        {
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C, 
            Ones, 
            Ones, 
            0x2C
        })
        Method (DPMM, 1, Serialized)
        {
            If (LEqual (Arg0, One))
            {
                Return (One)
            }
            Else
            {
                If (LEqual (Arg0, 0x02))
                {
                    Return (0x02)
                }
                Else
                {
                    Return (0x03)
                }
            }
        }

        Method (DPAH, 1, Serialized)
        {
            If (LEqual (Arg0, One))
            {
                Return (One)
            }
            Else
            {
                Return (0x03)
            }
        }

        Method (INDL, 0, Serialized)
        {
            Store (Zero, NXD1)
            Store (Zero, NXD2)
            Store (Zero, NXD3)
            Store (Zero, NXD4)
            Store (Zero, NXD5)
            Store (Zero, NXD6)
            Store (Zero, NXD7)
            Store (Zero, NXD8)
        }

        Method (SND1, 1, Serialized)
        {
            If (LEqual (Arg0, DID1))
            {
                Store (One, NXD1)
            }

            If (LEqual (Arg0, DID2))
            {
                Store (One, NXD2)
            }

            If (LEqual (Arg0, DID3))
            {
                Store (One, NXD3)
            }

            If (LEqual (Arg0, DID4))
            {
                Store (One, NXD4)
            }

            If (LEqual (Arg0, DID5))
            {
                Store (One, NXD5)
            }

            If (LEqual (Arg0, DID6))
            {
                Store (One, NXD6)
            }

            If (LEqual (Arg0, DID7))
            {
                Store (One, NXD7)
            }

            If (LEqual (Arg0, DID8))
            {
                Store (One, NXD8)
            }
        }

        Method (SNXD, 1, Serialized)
        {
            INDL ()
            Store (One, Local0)
            Store (Zero, Local1)
            While (LLess (Local0, Arg0))
            {
                If (LEqual (DerefOf (Index (TLPK, Local1)), 0x2C))
                {
                    Increment (Local0)
                }

                Increment (Local1)
            }

            SND1 (DerefOf (Index (TLPK, Local1)))
            Increment (Local1)
            If (LNotEqual (DerefOf (Index (TLPK, Local1)), 0x2C))
            {
                SND1 (DerefOf (Index (TLPK, Local1)))
            }
        }

        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            P8XH (One, 0xD1, P8XH (Zero, Local0, If (LEqual (Arg0, Buffer (
                0x10)
                            {
                                /* 0000 */   0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E,
                                /* 0008 */   0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                            }))
                    {
                        If (LEqual (Arg2, Zero))
                        {
                            Return (Buffer (0x04)
                            {
                                 0x03, 0x00, 0x00, 0x00
                            })
                        }

                        If (LEqual (Arg2, One))
                        {
                            Name (MXIF, Package (0x06)
                            {
                                0x05, 
                                Package (0x02)
                                {
                                    Zero, 
                                    Buffer (0x04)
                                    {
                                         0x01, 0x03, 0x03, 0x00
                                    }
                                }, 

                                Package (0x02)
                                {
                                    Zero, 
                                    Buffer (0x04)
                                    {
                                         0x02, 0x03, 0x03, 0x00
                                    }
                                }, 

                                Package (0x02)
                                {
                                    Zero, 
                                    Buffer (0x04)
                                    {
                                         0x08, 0x03, 0x03, 0x03
                                    }
                                }, 

                                Package (0x02)
                                {
                                    Zero, 
                                    Buffer (0x04)
                                    {
                                         0x04, 0x03, 0x03, 0x03
                                    }
                                }, 

                                Package (0x02)
                                {
                                    Zero, 
                                    Buffer (0x04)
                                    {
                                         0x05, 0x03, 0x03, 0x03
                                    }
                                }
                            })
                            Store (DID1, Index (DerefOf (Index (MXIF, One)), Zero))
                            Store (DID2, Index (DerefOf (Index (MXIF, 0x02)), Zero))
                            Store (DID3, Index (DerefOf (Index (MXIF, 0x03)), Zero))
                            Store (DID4, Index (DerefOf (Index (MXIF, 0x04)), Zero))
                            Store (DID5, Index (DerefOf (Index (MXIF, 0x05)), Zero))
                            Store (DPMM (DPBM), Local0)
                            Store (DPMM (DPBM), Index (DerefOf (Index (DerefOf (Index (MXIF, 0x03
                                )), One)), One))
                            Store (DPAH (DPBM), Local0)
                            Store (Local0, Index (DerefOf (Index (DerefOf (Index (MXIF, 0x03)), 
                                One)), 0x02))
                            Store (Local0, Index (DerefOf (Index (DerefOf (Index (MXIF, 0x03)), 
                                One)), 0x03))
                            Store (DPMM (DPBM), Index (DerefOf (Index (DerefOf (Index (MXIF, 0x04
                                )), One)), One))
                            Store (Local0, Index (DerefOf (Index (DerefOf (Index (MXIF, 0x04)), 
                                One)), 0x02))
                            Store (Local0, Index (DerefOf (Index (DerefOf (Index (MXIF, 0x04)), 
                                One)), 0x03))
                            Store (DPMM (DPCM), Index (DerefOf (Index (DerefOf (Index (MXIF, 0x05
                                )), One)), One))
                            Store (DPAH (DPCM), Local0)
                            Store (Local0, Index (DerefOf (Index (DerefOf (Index (MXIF, 0x05)), 
                                One)), 0x02))
                            Store (Local0, Index (DerefOf (Index (DerefOf (Index (MXIF, 0x05)), 
                                One)), 0x03))
                            If (LEqual (ALFP, 0x07))
                            {
                                Store (0x0A, Index (DerefOf (Index (DerefOf (Index (MXIF, 0x02)), 
                                    One)), Zero))
                            }

                            Return (MXIF)
                        }

                        Return (One)
                    }, If (LEqual (Arg0, Buffer (0x10)
                            {
                                /* 0000 */   0xA0, 0xA0, 0x95, 0x9D, 0x60, 0x00, 0x48, 0x4D,
                                /* 0008 */   0xB3, 0x4D, 0x7E, 0x5F, 0xEA, 0x12, 0x9F, 0xD4
                            }))
                    {
                        P8XH (One, 0xD2, P8XH (Zero, Arg2, If (LNotEqual (Arg1, 
                            0x0102))
                                {
                                    Return (0x80000002)
                                }, If (LEqual (Arg2, Zero))
                                {
                                    Return (Buffer (0x04)
                                    {
                                         0x7F, 0x00, 0x04, 0x00
                                    })
                                }, If (LEqual (Arg2, One))
                                {
                                    Name (TEMP, Buffer (0x04)
                                    {
                                         0x00, 0x00, 0x00, 0x00
                                    })
                                    CreateDWordField (TEMP, Zero, STS0)
                                    Or (STS0, 0x0B0000BF, STS0)
                                    Or (STS0, ShiftLeft (HGNC, 0x08, HGNC), STS0)
                                    Return (TEMP)
                                }), If (LEqual (Arg2, 0x02))
                            {
                                Name (TMP1, Buffer (0x04)
                                {
                                     0x00, 0x00, 0x00, 0x00
                                })
                                CreateDWordField (TMP1, Zero, STS1)
                                ToInteger (Arg3, Local0)
                                And (Local0, 0x1F, Local0)
                                If (And (Local0, 0x10))
                                {
                                    And (Local0, 0x0F, Local0)
                                    Store (Local0, GPSS)
                                    Notify (\_SB.PCI0.GFX0, 0xD9)
                                    Notify (\_SB.PCI0.WMI1, 0xD9)
                                }
                                Else
                                {
                                    And (Local0, 0x0F, Local0)
                                    If (LEqual (GPPO, One))
                                    {
                                        Store (GPSS, Local0)
                                        Or (Local0, 0x10, Local0)
                                        Store (Zero, GPPO)
                                    }
                                }

                                Or (STS1, Local0, STS1)
                                Return (TMP1)
                            }, If (LEqual (Arg2, 0x03))
                            {
                                Name (TMP2, Buffer (0x04)
                                {
                                     0x00, 0x00, 0x00, 0x00
                                })
                                CreateDWordField (TMP2, Zero, STS2)
                                ToInteger (Arg3, Local0)
                                And (Local0, 0x03, Local0)
                                If (LEqual (Local0, Zero))
                                {
                                    \_SB.PCI0.P0P1.PEGP._STA ()
                                }

                                If (LEqual (Local0, One))
                                {
                                    \_SB.PCI0.P0P1.PEGP._ON ()
                                }

                                If (LEqual (Local0, 0x02))
                                {
                                    \_SB.PCI0.P0P1.PEGP._OFF ()
                                }

                                If (LEqual (\_SB.PCI0.P0P1.PEGP.PO36, Zero))
                                {
                                    Or (STS2, One, STS2)
                                }

                                Return (TMP2)
                            })
                        If (LEqual (Arg2, 0x04))
                        {
                            Name (TMP3, Buffer (0x04)
                            {
                                 0x00, 0x00, 0x00, 0x00
                            })
                            CreateDWordField (TMP3, Zero, STS3)
                            ToInteger (Arg3, Local0)
                            Store (Local0, Local1)
                            ShiftRight (Local0, 0x10, Local0)
                            And (Local0, One, USPM)
                            ShiftRight (Local1, 0x0D, Local1)
                            And (Local1, 0x03, Local1)
                            If (LNotEqual (Local1, GPSP))
                            {
                                If (LEqual (USPM, One))
                                {
                                    Store (Local1, GPSP)
                                }
                                Else
                                {
                                    Store (GPSP, Local1)
                                    Or (STS3, 0x8000, STS3)
                                }
                            }

                            Or (STS3, ShiftLeft (Local1, 0x0D), STS3)
                            Return (TMP3)
                        }

                        If (LEqual (Arg2, 0x05))
                        {
                            Name (TMP4, Buffer (0x04)
                            {
                                 0x00, 0x00, 0x00, 0x00
                            })
                            CreateDWordField (TMP4, Zero, STS4)
                            ToInteger (Arg3, Local0)
                            If (And (Local0, 0x80000000))
                            {
                                Store (And (ShiftRight (Local0, 0x19), 0x1F), TLSN)
                                If (And (Local0, 0x40000000))
                                {
                                    Store (One, DOSF)
                                }
                            }

                            If (And (Local0, 0x01000000))
                            {
                                Store (And (ShiftRight (Local0, 0x0C), 0x0FFF), GACD)
                                Store (And (Local0, 0x0FFF), GATD)
                                Store (CTOI (GACD), TLSN)
                                Increment (TLSN)
                                If (LGreater (TLSN, 0x09))
                                {
                                    Store (One, TLSN)
                                }

                                SNXD (TLSN)
                            }

                            Or (STS4, ShiftLeft (DHPE, 0x15), STS4)
                            Or (STS4, ShiftLeft (DHPS, 0x14), STS4)
                            Or (STS4, ShiftLeft (TLSN, 0x08), STS4)
                            Or (STS4, ShiftLeft (DKST, 0x05), STS4)
                            Or (STS4, ShiftLeft (LDES, 0x04), STS4)
                            Or (STS4, DACE, STS4)
                            Store (Zero, LDES)
                            Store (Zero, DHPS)
                            Store (Zero, DHPE)
                            Store (Zero, DACE)
                            Return (TMP4)
                        }

                        If (LEqual (Arg2, 0x06))
                        {
                            Return (TLPK)
                        }

                        If (LEqual (Arg2, 0x12))
                        {
                            Return (Package (0x06)
                            {
                                0xD0, 
                                Buffer (0x10)
                                {
                                    /* 0000 */   0x40, 0x2F, 0x1A, 0x92, 0xC4, 0x0D, 0x2D, 0x40,
                                    /* 0008 */   0xAC, 0x18, 0xB4, 0x84, 0x44, 0xEF, 0x9E, 0xD2
                                }, 

                                0xD9, 
                                Buffer (0x10)
                                {
                                    /* 0000 */   0x61, 0xD3, 0x2A, 0xC1, 0xA9, 0x9F, 0x74, 0x4C,
                                    /* 0008 */   0x90, 0x1F, 0x95, 0xCB, 0x09, 0x45, 0xCF, 0x3E
                                }, 

                                0xDB, 
                                Buffer (0x10)
                                {
                                    /* 0000 */   0x06, 0x80, 0x84, 0x42, 0x86, 0x88, 0x0E, 0x49,
                                    /* 0008 */   0x8C, 0x72, 0x2B, 0xDC, 0xA9, 0x3A, 0x8A, 0x09
                                }
                            })
                        }

                        Return (0x80000002)
                    }, Return (0x80000001)))
        }

        Method (CTOI, 1, Serialized)
        {
            Name (_T_0, Zero)
            Store (ToInteger (Arg0), _T_0)
            If (LEqual (_T_0, One))
            {
                Return (One)
            }
            Else
            {
                If (LEqual (_T_0, 0x02))
                {
                    Return (0x02)
                }
                Else
                {
                    If (LEqual (_T_0, 0x04))
                    {
                        Return (0x03)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x08))
                        {
                            Return (0x04)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x10))
                            {
                                Return (0x05)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x03))
                                {
                                    Return (0x06)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x06))
                                    {
                                        Return (0x07)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x0A))
                                        {
                                            Return (0x08)
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x12))
                                            {
                                                Return (0x09)
                                            }
                                            Else
                                            {
                                                Return (One)
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    Scope (\_SB.PCI0.P0P1)
    {
        OperationRegion (RPCI, SystemMemory, 0xE0008000, 0x1000)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
            Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
                ,   1, 
            RCCC,   1, 
            Offset (0x1FC), 
                ,   9, 
            SGL1,   1, 
            Offset (0x214), 
            Offset (0x216), 
            LNKS,   4, 
            Offset (0x224), 
            Offset (0x225), 
            DQDA,   1, 
            Offset (0xC28), 
            HCLQ,   1, 
            Offset (0xC34), 
                ,   30, 
            PEDQ,   1, 
            PIDQ,   1, 
            Offset (0xDFC), 
                ,   1, 
            PEPO,   3, 
            Offset (0xE08), 
                ,   31, 
            ROE0,   1, 
            Offset (0xE28), 
                ,   31, 
            ROE1,   1, 
            Offset (0xE48), 
                ,   31, 
            ROE2,   1, 
            Offset (0xE68), 
                ,   31, 
            ROE3,   1, 
            Offset (0xE88), 
                ,   31, 
            ROE4,   1, 
            Offset (0xEA8), 
                ,   31, 
            ROE5,   1, 
            Offset (0xEC8), 
                ,   31, 
            ROE6,   1, 
            Offset (0xEE8), 
                ,   31, 
            ROE7,   1, 
            Offset (0xF08), 
                ,   31, 
            ROE8,   1, 
            Offset (0xF28), 
                ,   31, 
            ROE9,   1, 
            Offset (0xF48), 
                ,   31, 
            ROEA,   1, 
            Offset (0xF68), 
                ,   31, 
            ROEB,   1, 
            Offset (0xF88), 
                ,   31, 
            ROEC,   1, 
            Offset (0xFA8), 
                ,   31, 
            ROED,   1, 
            Offset (0xFC8), 
                ,   31, 
            ROEE,   1, 
            Offset (0xFE8), 
                ,   31, 
            ROEF,   1
        }

        OperationRegion (DMIB, SystemMemory, 0xFED18000, 0x1000)
        Field (DMIB, DWordAcc, Lock, Preserve)
        {
            Offset (0xC34), 
            LLGE,   1, 
                ,   28, 
            PCGE,   1, 
                ,   1, 
            LGGE,   1
        }
    }

    Scope (\_SB.PCI0.P0P1.PEGP)
    {
        OperationRegion (CMS1, SystemIO, 0x72, One)
        Field (CMS1, ByteAcc, NoLock, Preserve)
        {
            PT72,   8
        }

        OperationRegion (CMS2, SystemIO, 0x73, One)
        Field (CMS2, ByteAcc, NoLock, Preserve)
        {
            PT73,   8
        }

        Name (OPCM, One)
        Name (OPCE, 0x02)
        Name (_PSC, Zero)
        OperationRegion (BPCI, SystemMemory, 0xE0100000, 0x0100)
        Field (BPCI, ByteAcc, NoLock, Preserve)
        {
            VGAR,   2048
        }

        Name (VGAB, Buffer (0x0100)
        {
            /* 0000 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0008 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0010 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0018 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0020 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0028 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0030 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0038 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0040 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0048 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0050 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0058 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0060 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0068 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0070 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0078 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0080 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0088 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0090 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
            /* 0098 */   0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00
        })
        Method (_STA, 0, Serialized)
        {
            Return (0x0F)
        }

        OperationRegion (GPIO, SystemIO, 0x0500, 0x4A)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
            Offset (0x0C), 
            Offset (0x0E), 
            PO16,   1, 
            PI17,   1, 
            Offset (0x30), 
                ,   15, 
            GP47,   1, 
            Offset (0x38), 
                ,   4, 
            PO36,   1, 
            PI37,   1, 
                ,   9, 
            PI47,   1, 
                ,   4, 
            PO52,   1, 
            PO53,   1, 
            Offset (0x48), 
                ,   3, 
            PO67,   1
        }

        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.P0P1.PEGP._ADR)
        }

        Name (DGPS, Zero)
        Method (_PS0, 0, NotSerialized)
        {
            Store (Zero, _PSC)
            If (LNotEqual (DGPS, Zero))
            {
                \_SB.PCI0.P0P1.PEGP._ON ()
                Store (Zero, DGPS)
            }
        }

        Method (_PS1, 0, NotSerialized)
        {
            Store (One, _PSC)
        }

        Method (_PS3, 0, NotSerialized)
        {
            If (LEqual (OPCE, 0x03))
            {
                If (LEqual (DGPS, Zero))
                {
                    \_SB.PCI0.P0P1.PEGP._OFF ()
                    Store (One, DGPS)
                }

                Store (0x02, OPCE)
            }

            Store (0x03, _PSC)
        }

        OperationRegion (VROM, SystemMemory, 0xA75E3018, 0x00010000)
        Field (VROM, AnyAcc, NoLock, Preserve)
        {
            RBF1,   262144, 
            RBF2,   262144
        }

        Method (_ROM, 2, NotSerialized)
        {
            P8XH (One, 0x44, P8XH (Zero, One, Store (Arg0, Local0), Store (
                Arg1, Local1), CreateWordField (RBF1, 0x02, RVBS)), ShiftLeft (And (RVBS, 0xFF), 
                0x09, RVBS), If (LGreater (Local1, 0x1000))
                {
                    Store (0x1000, Local1)
                })
            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                     0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                 0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                 0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }

        Name (NBL1, Package (0x10)
        {
            0x13, 
            0x23, 
            0x19, 
            0x77, 
            0xBB, 
            0xEE, 
            0x9D, 
            0x66, 
            0x7E, 
            0xCB, 
            0xD9, 
            0x0A, 
            0x91, 
            0xF1, 
            0xE7, 
            0x6D
        })
        Name (OPCO, Buffer (0xE6)
        {
            /* 0000 */   0x7B, 0x05, 0xB1, 0xE5, 0x4D, 0xFA, 0x21, 0x80,
            /* 0008 */   0x4B, 0x56, 0xE6, 0x00, 0x00, 0x00, 0x01, 0x00,
            /* 0010 */   0x31, 0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35,
            /* 0018 */   0x36, 0x39, 0x38, 0x35, 0x47, 0x65, 0x6E, 0x75,
            /* 0020 */   0x69, 0x6E, 0x65, 0x20, 0x4E, 0x56, 0x49, 0x44,
            /* 0028 */   0x49, 0x41, 0x20, 0x43, 0x65, 0x72, 0x74, 0x69,
            /* 0030 */   0x66, 0x69, 0x65, 0x64, 0x20, 0x4F, 0x70, 0x74,
            /* 0038 */   0x69, 0x6D, 0x75, 0x73, 0x20, 0x52, 0x65, 0x61,
            /* 0040 */   0x64, 0x79, 0x20, 0x4D, 0x6F, 0x74, 0x68, 0x65,
            /* 0048 */   0x72, 0x62, 0x6F, 0x61, 0x72, 0x64, 0x20, 0x66,
            /* 0050 */   0x6F, 0x72, 0x20, 0x36, 0x39, 0x33, 0x30, 0x32,
            /* 0058 */   0x39, 0x5F, 0x4E, 0x49, 0x43, 0x48, 0x4F, 0x4C,
            /* 0060 */   0x53, 0x63, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
            /* 0068 */   0x2D, 0x20, 0x49, 0x49, 0x25, 0x2B, 0x46, 0x5E,
            /* 0070 */   0x32, 0x4D, 0x37, 0x37, 0x26, 0x2C, 0x47, 0x4B,
            /* 0078 */   0x53, 0x43, 0x49, 0x22, 0x26, 0x21, 0x49, 0x3B,
            /* 0080 */   0x3C, 0x43, 0x20, 0x2F, 0x53, 0x2C, 0x4C, 0x2C,
            /* 0088 */   0x5D, 0x4B, 0x44, 0x5E, 0x27, 0x54, 0x4C, 0x27,
            /* 0090 */   0x4C, 0x5C, 0x22, 0x47, 0x52, 0x32, 0x49, 0x58,
            /* 0098 */   0x51, 0x5F, 0x41, 0x33, 0x50, 0x41, 0x20, 0x2D,
            /* 00A0 */   0x20, 0x43, 0x6F, 0x70, 0x79, 0x72, 0x69, 0x67,
            /* 00A8 */   0x68, 0x74, 0x20, 0x32, 0x30, 0x31, 0x30, 0x20,
            /* 00B0 */   0x4E, 0x56, 0x49, 0x44, 0x49, 0x41, 0x20, 0x43,
            /* 00B8 */   0x6F, 0x72, 0x70, 0x6F, 0x72, 0x61, 0x74, 0x69,
            /* 00C0 */   0x6F, 0x6E, 0x20, 0x41, 0x6C, 0x6C, 0x20, 0x52,
            /* 00C8 */   0x69, 0x67, 0x68, 0x74, 0x73, 0x20, 0x52, 0x65,
            /* 00D0 */   0x73, 0x65, 0x72, 0x76, 0x65, 0x64, 0x2D, 0x31,
            /* 00D8 */   0x34, 0x38, 0x35, 0x39, 0x37, 0x34, 0x35, 0x36,
            /* 00E0 */   0x39, 0x38, 0x35, 0x28, 0x52, 0x29
        })
        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            P8XH (One, 0xDD, P8XH (Zero, Local0, If (LEqual (Arg0, Buffer (
                0x10)
                            {
                                /* 0000 */   0x75, 0x0B, 0xA5, 0xD4, 0xC7, 0x65, 0xF7, 0x46,
                                /* 0008 */   0xBF, 0xB7, 0x41, 0x51, 0x4C, 0xEA, 0x02, 0x44
                            }))
                    {
                        Store ("----- dGPU 3D VISION & 3DTV _DSM----------", Debug)
                        If (LNotEqual (Arg1, 0x0102))
                        {
                            Return (0x80000002)
                        }

                        Name (_T_0, Zero)
                        Store (ToInteger (Arg2), _T_0)
                        If (LEqual (_T_0, Zero))
                        {
                            Return (Buffer (0x04)
                            {
                                 0x01, 0x00, 0x40, 0x00
                            })
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x04))
                            {
                                Return (Buffer (0x04)
                                {
                                     0x00, 0x1C, 0x00, 0x00
                                })
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x16))
                                {
                                    If (LEqual (ToInteger (Arg3), 0x02))
                                    {
                                        Return (NBL1)
                                    }
                                }
                            }
                        }
                    }, Store ("----- dGPU _DSM --------", Debug), If (LEqual (Arg0, Buffer (0x10)
                            {

                                                                            /* 0000 */   0xFD, 0x88, 0xDB, 0x95, 0x0A, 0x94, 0x53, 0x42,
                                /* 0008 */   0xA4, 0x46, 0x70, 0xCE, 0x05, 0x04, 0xAE, 0xDF
                            }))
                    {
                        Return (SPB (Arg0, Arg1, Arg2, Arg3))
                    }), If (LEqual (Arg0, Buffer (
                            0x10)
                        {
                            /* 0000 */   0xF8, 0xD8, 0x86, 0xA4, 0xDA, 0x0B, 0x1B, 0x47,
                            /* 0008 */   0xA7, 0x2B, 0x60, 0x42, 0xA6, 0xB5, 0xBE, 0xE0
                        }))
                {
                    If (LNotEqual (Arg1, 0x0100))
                    {
                        Return (Buffer (0x04)
                        {
                             0x02, 0x00, 0x00, 0x80
                        })
                    }

                    Name (_T_1, Zero)
                    Store (ToInteger (Arg2), _T_1)
                    If (LEqual (_T_1, Zero))
                    {
                        Return (Buffer (0x04)
                        {
                             0x61, 0x00, 0x01, 0x0C
                        })
                    }
                    Else
                    {
                        If (LEqual (_T_1, 0x05))
                        {
                            Store ("------- NV OPTIMUS DSM --------", Debug)
                            Name (TMP4, Buffer (0x04)
                            {
                                 0x00, 0x00, 0x00, 0x00
                            })
                            CreateDWordField (TMP4, Zero, STS4)
                            ToInteger (Arg3, Local0)
                            If (And (Local0, 0x80000000))
                            {
                                Store (And (ShiftRight (Local0, 0x19), 0x1F), \_SB.PCI0.GFX0.TLSN)
                                If (And (Local0, 0x40000000))
                                {
                                    Store (One, \_SB.PCI0.GFX0.DOSF)
                                }
                            }

                            If (And (Local0, 0x01000000))
                            {
                                Store (And (ShiftRight (Local0, 0x0C), 0x0FFF), \_SB.PCI0.GFX0.GACD)
                                Store (And (Local0, 0x0FFF), \_SB.PCI0.GFX0.GATD)
                                Store (\_SB.PCI0.GFX0.CTOI (\_SB.PCI0.GFX0.GACD), \_SB.PCI0.GFX0.TLSN)
                                Increment (\_SB.PCI0.GFX0.TLSN)
                                If (LGreater (\_SB.PCI0.GFX0.TLSN, 0x09))
                                {
                                    Store (One, \_SB.PCI0.GFX0.TLSN)
                                }

                                \_SB.PCI0.GFX0.SNXD (\_SB.PCI0.GFX0.TLSN)
                            }

                            Or (STS4, ShiftLeft (\_SB.PCI0.GFX0.DHPE, 0x15), STS4)
                            Or (STS4, ShiftLeft (\_SB.PCI0.GFX0.DHPS, 0x14), STS4)
                            Or (STS4, ShiftLeft (\_SB.PCI0.GFX0.TLSN, 0x08), STS4)
                            Or (STS4, ShiftLeft (\_SB.PCI0.GFX0.DKST, 0x05), STS4)
                            Or (STS4, ShiftLeft (\_SB.PCI0.GFX0.LDES, 0x04), STS4)
                            Or (STS4, \_SB.PCI0.GFX0.DACE, STS4)
                            Store (Zero, \_SB.PCI0.GFX0.LDES)
                            Store (Zero, \_SB.PCI0.GFX0.DHPS)
                            Store (Zero, \_SB.PCI0.GFX0.DHPE)
                            Store (Zero, \_SB.PCI0.GFX0.DACE)
                            Return (Buffer (0x04)
                            {
                                 0x00, 0x00, 0x50, 0x00
                            })
                        }
                        Else
                        {
                            If (LEqual (_T_1, 0x06))
                            {
                                Store ("------- NV OPTIMUS DSM --------", Debug)
                                Return (\_SB.PCI0.GFX0.TLPK)
                            }
                            Else
                            {
                                If (LEqual (_T_1, 0x10))
                                {
                                    Return (OPCO)
                                }
                                Else
                                {
                                    If (LEqual (_T_1, 0x1A))
                                    {
                                        Store (Zero, Local0)
                                        Store (ShiftLeft (DerefOf (Index (Arg3, 0x03)), 0x18), Local0)
                                        Add (ShiftLeft (DerefOf (Index (Arg3, 0x02)), 0x10), Local0, 
                                            Local0)
                                        Add (ShiftLeft (DerefOf (Index (Arg3, One)), 0x08), Local0, 
                                            Local0)
                                        Add (ShiftLeft (DerefOf (Index (Arg3, Zero)), Zero), Local0, 
                                            Local0)
                                        If (And (Local0, One))
                                        {
                                            ShiftRight (Local0, 0x18, Local2)
                                            If (LEqual (Local2, 0x03))
                                            {
                                                Store (0x03, OPCE)
                                            }
                                        }

                                        Name (TMP1, Buffer (0x04)
                                        {
                                             0xD8, 0x00, 0x00, 0x11
                                        })
                                        CreateField (TMP1, 0x1B, 0x02, HDAC)
                                        CreateField (TMP1, 0x18, 0x03, DGPC)
                                        CreateField (TMP1, Zero, One, OPEN)
                                        CreateField (TMP1, 0x03, 0x02, CGCS)
                                        If (OPCM)
                                        {
                                            Store (One, OPEN)
                                            Store (One, DGPC)
                                            Store (0x02, HDAC)
                                            If (One)
                                            {
                                                Store (\_SB.PCI0.SBRG.EC0.GPWR, Local1)
                                                If (Not (Local1))
                                                {
                                                    Store (0x03, CGCS)
                                                }
                                            }
                                            Else
                                            {
                                                If (Not (PO36))
                                                {
                                                    Store (0x03, CGCS)
                                                }
                                            }
                                        }

                                        Return (TMP1)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_1, 0x1B))
                                        {
                                            Store (DerefOf (Index (Arg3, Zero)), Local0)
                                            And (Local0, 0x02, Local1)
                                            P8XH (Zero, Local1, If (LEqual (Local1, 0x02))
                                                {
                                                    Store (0x28, PT72)
                                                    And (Local0, One, Local0)
                                                    Store (Local0, PT73)
                                                }, Return (Arg3), Return (Buffer (0x04)
                                                {
                                                     0x02, 0x00, 0x00, 0x80
                                                }))
                                        }
                                    }
                                }
                            }
                        }
                    }
                }, Return (
                                                        0x80000001))
        }

        Method (_DOD, 0, NotSerialized)
        {
            Return (0x80007330)
        }

        Device (HDMI)
        {
            Name (_ADR, 0x80007330)
            Method (_DCS, 0, NotSerialized)
            {
                Return (0x1F)
            }
        }

        Method (_ON, 0, Serialized)
        {
            Store (0x21, DBG8)
            If (Zero)
            {
                If (LEqual (PO36, Zero))
                {
                    Store (Zero, PO16)
                    Sleep (0x32)
                    Store (One, PO36)
                    Sleep (0x012C)
                    Store (One, PO16)
                    Sleep (0x64)
                    Store (Zero, LLGE)
                    Store (Zero, LGGE)
                    Store (Zero, PEPO)
                    Store (Zero, ROE0)
                    Store (Zero, ROE1)
                    Store (Zero, ROE2)
                    Store (Zero, ROE3)
                    Store (Zero, ROE4)
                    Store (Zero, ROE5)
                    Store (Zero, ROE6)
                    Store (Zero, ROE7)
                    Store (Zero, ROE8)
                    Store (Zero, ROE9)
                    Store (Zero, ROEA)
                    Store (Zero, ROEB)
                    Store (Zero, ROEC)
                    Store (Zero, ROED)
                    Store (Zero, ROEE)
                    Store (Zero, ROEF)
                    Store (Zero, PCGE)
                    Store (Zero, HCLQ)
                    Store (Zero, PEDQ)
                    Store (Zero, LNKD)
                    Store (One, LLGE)
                    Store (One, LGGE)
                    Sleep (0x64)
                    Store (0x64, Local1)
                    While (Local1)
                    {
                        Sleep (One)
                        Decrement (Local1)
                        If (LEqual (LNKS, 0x07))
                        {
                            Store (Zero, Local1)
                        }
                    }

                    Sleep (0x03E8)
                    Store (VGAB, VGAR)
                    Sleep (0x64)
                }
            }
            Else
            {
                Store (\_SB.PCI0.SBRG.EC0.GPWR, Local0)
                P8XH (Zero, Local0, If (LEqual (Local0, Zero))
                    {
                        Store (One, GP47)
                        Store (One, PI47)
                        Sleep (0x32)
                        Store (One, \_SB.PCI0.SBRG.EC0.GPWR)
                        Sleep (0x32)
                        Store (Zero, GP47)
                        Store (Zero, PI47)
                        Store (Zero, LLGE)
                        Store (Zero, LGGE)
                        Store (Zero, PEPO)
                        Store (Zero, ROE0)
                        Store (Zero, ROE1)
                        Store (Zero, ROE2)
                        Store (Zero, ROE3)
                        Store (Zero, ROE4)
                        Store (Zero, ROE5)
                        Store (Zero, ROE6)
                        Store (Zero, ROE7)
                        Store (Zero, ROE8)
                        Store (Zero, ROE9)
                        Store (Zero, ROEA)
                        Store (Zero, ROEB)
                        Store (Zero, ROEC)
                        Store (Zero, ROED)
                        Store (Zero, ROEE)
                        Store (Zero, ROEF)
                        Store (Zero, PCGE)
                        Store (Zero, HCLQ)
                        Store (Zero, PEDQ)
                        Store (Zero, LNKD)
                        Store (One, LLGE)
                        Store (One, LGGE)
                        Sleep (0x64)
                        Store (0x64, Local1)
                        While (Local1)
                        {
                            Sleep (One)
                            Decrement (Local1)
                            If (LEqual (LNKS, 0x07))
                            {
                                Store (Zero, Local1)
                            }
                        }

                        Sleep (0x03E8)
                        Store (VGAB, VGAR)
                        Sleep (0x64)
                    })
            }
        }

        Method (_OFF, 0, Serialized)
        {
            Store (0x20, DBG8)
            Store (VGAR, VGAB)
            Sleep (0x64)
            Store (Zero, LLGE)
            Store (Zero, LGGE)
            Store (One, LNKD)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            Store (One, PEDQ)
            Store (Zero, LNKD)
            While (LNotEqual (PIDQ, One))
            {
                Sleep (One)
            }

            Store (One, PCGE)
            Store (One, HCLQ)
            Store (0x03, PEPO)
            Store (One, ROE0)
            Store (One, ROE1)
            Store (One, ROE2)
            Store (One, ROE3)
            Store (One, ROE4)
            Store (One, ROE5)
            Store (One, ROE6)
            Store (One, ROE7)
            Store (One, ROE8)
            Store (One, ROE9)
            Store (One, ROEA)
            Store (One, ROEB)
            Store (One, ROEC)
            Store (One, ROED)
            Store (One, ROEE)
            Store (One, ROEF)
            Store (One, LLGE)
            Store (One, LGGE)
            If (Zero)
            {
                Store (Zero, PO16)
                Sleep (0x64)
                Store (Zero, PO36)
            }
            Else
            {
                Store (Zero, \_SB.PCI0.SBRG.EC0.GPWR)
            }
        }
    }

    Scope (\_SB.PCI0.P0P1.PEGP)
    {
        Name (VSTS, One)
        Name (THBG, 0xC350)
        Name (PSCP, Zero)
        Name (TBUD, 0xF230)
        Method (THCH, 2, NotSerialized)
        {
            Name (_T_0, Zero)
            Store (ToInteger (Arg0), _T_0)
            If (LEqual (_T_0, 0x03))
            {
                Store (DerefOf (Arg1), VSTS)
                Notify (\_SB.PCI0.P0P1.PEGP, 0xC0)
            }
            Else
            {
                If (LEqual (_T_0, One))
                {
                    Store (DerefOf (Arg1), THBG)
                    Notify (\_SB.PCI0.P0P1.PEGP, 0xC1)
                }
            }
        }

        Method (SPB2, 2, NotSerialized)
        {
            Store (Buffer (0x04)
                {
                     0x00, 0x00, 0x00, 0x00
                }, Local0)
            CreateDWordField (Local0, Zero, LLLL)
            Store (Arg1, LLLL)
            Return (SPB (Zero, 0x0101, Arg0, Local0))
        }

        Method (SPB, 4, NotSerialized)
        {
            Return (0x80000002)
            Store ("------- SPB DSM --------", Debug)
            If (LNotEqual (Arg1, 0x0101))
            {
                Return (0x80000002)
            }

            Name (_T_0, Zero)
            Store (ToInteger (Arg2), _T_0)
            If (LEqual (_T_0, Zero))
            {
                Name (FMSK, Buffer (0x08)
                {
                     0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
                })
                Store (Buffer (0x08)
                    {
                         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                    }, Local0)
                Divide (Zero, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x20, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x21, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x22, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x23, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x24, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x2A, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Store (SizeOf (Local0), Local1)
                While (LNotEqual (Local1, Zero))
                {
                    Decrement (Local1)
                    Store (DerefOf (Index (FMSK, Local1)), Local2)
                    And (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                        ))
                }

                Return (Local0)
            }
            Else
            {
                If (LEqual (_T_0, 0x20))
                {
                    Store (TBUD, Local1)
                    And (Local1, 0x000FFFFF, Local1)
                    Or (Local1, 0x40000000, Local1)
                    Return (Local1)
                }
                Else
                {
                    If (LEqual (_T_0, 0x21))
                    {
                        Return (\_PR.P000._PSS)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x22))
                        {
                            CreateByteField (Arg3, Zero, PCAP)
                            Store (PCAP, PSCP)
                            Store (PCAP, \PSTE)
                            Notify (\_PR.P000, 0x80)
                            If (CondRefOf (\_PR.CPU1._PPC, Local0))
                            {
                                Store (PCAP, \PSTE)
                                Notify (\_PR.P001, 0x80)
                            }

                            If (CondRefOf (\_PR.CPU2._PPC, Local0))
                            {
                                Store (PCAP, \PSTE)
                                Notify (\_PR.P002, 0x80)
                            }

                            If (CondRefOf (\_PR.CPU3._PPC, Local0))
                            {
                                Store (PCAP, \PSTE)
                                Notify (\_PR.P003, 0x80)
                            }

                            Return (PCAP)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x23))
                            {
                                Return (PSCP)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x24))
                                {
                                    CreateField (Arg3, Zero, 0x14, THBG)
                                    CreateField (Arg3, 0x1E, One, DDVE)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x2A))
                                    {
                                        Return (SSNR (Arg3))
                                    }
                                }
                            }
                        }
                    }
                }
            }

            Return (0x80000002)
        }

        Name (SBHS, Buffer (0x08) {})
        CreateDWordField (SBHS, Zero, VERV)
        CreateDWordField (SBHS, 0x04, NUMS)
        Name (SSCP, Buffer (0x2C) {})
        CreateDWordField (SSCP, 0x04, CSNT)
        CreateDWordField (SSCP, 0x08, CPTI)
        CreateDWordField (SSCP, 0x0C, CICA)
        CreateDWordField (SSCP, 0x10, CIRC)
        CreateDWordField (SSCP, 0x14, CICV)
        CreateDWordField (SSCP, 0x18, CIRA)
        CreateDWordField (SSCP, 0x1C, CIAV)
        CreateDWordField (SSCP, 0x20, CIEP)
        CreateDWordField (SSCP, 0x24, CPPF)
        CreateDWordField (SSCP, 0x28, CSNR)
        Name (SSGP, Buffer (0x2C) {})
        CreateDWordField (SSGP, 0x04, GSNT)
        CreateDWordField (SSGP, 0x08, GPTI)
        CreateDWordField (SSGP, 0x0C, GICA)
        CreateDWordField (SSGP, 0x10, GIRC)
        CreateDWordField (SSGP, 0x14, GICV)
        CreateDWordField (SSGP, 0x18, GIRA)
        CreateDWordField (SSGP, 0x1C, GIAV)
        CreateDWordField (SSGP, 0x20, GIEP)
        CreateDWordField (SSGP, 0x24, GPPF)
        CreateDWordField (SSGP, 0x28, GSNR)
        Name (SCPP, Buffer (0x48) {})
        CreateDWordField (SCPP, Zero, VRV1)
        CreateDWordField (SCPP, 0x04, VCAP)
        CreateDWordField (SCPP, 0x08, VCCP)
        CreateDWordField (SCPP, 0x0C, VCDP)
        CreateDWordField (SCPP, 0x10, VCEP)
        CreateDWordField (SCPP, 0x14, VCGP)
        CreateDWordField (SCPP, 0x18, VCHP)
        CreateDWordField (SCPP, 0x1C, VCXP)
        CreateDWordField (SCPP, 0x20, VCYP)
        CreateDWordField (SCPP, 0x24, VCZP)
        CreateDWordField (SCPP, 0x28, VCKP)
        CreateDWordField (SCPP, 0x2C, VCMP)
        CreateDWordField (SCPP, 0x30, VCNP)
        CreateDWordField (SCPP, 0x34, VCAL)
        CreateDWordField (SCPP, 0x38, VCBE)
        CreateDWordField (SCPP, 0x3C, VCGA)
        CreateDWordField (SCPP, 0x40, VCPP)
        CreateDWordField (SCPP, 0x44, VCDE)
        Name (SGPP, Buffer (0x28) {})
        CreateDWordField (SGPP, Zero, VRV2)
        CreateDWordField (SGPP, 0x04, VGWP)
        CreateDWordField (SGPP, 0x08, VGPP)
        CreateDWordField (SGPP, 0x0C, VGQP)
        CreateDWordField (SGPP, 0x10, VGRP)
        CreateDWordField (SGPP, 0x14, VGAP)
        CreateDWordField (SGPP, 0x18, VGBP)
        CreateDWordField (SGPP, 0x1C, VGCP)
        CreateDWordField (SGPP, 0x20, VGDP)
        CreateDWordField (SGPP, 0x24, VGDE)
        Method (SSNR, 1, NotSerialized)
        {
            Name (_T_0, Zero)
            Store (ToInteger (Arg0), _T_0)
            If (LEqual (_T_0, Zero))
            {
                Store (0x00010000, VERV)
                Store (0x02, NUMS)
                Return (SBHS)
            }
            Else
            {
                If (LEqual (_T_0, One))
                {
                    Store (0x00010000, VRV1)
                    Store (0x03E8, VCAP)
                    Store (0x02EE, VCCP)
                    Store (0x02EE, VCDP)
                    Store (0x02EE, VCEP)
                    Store (0x0514, VCGP)
                    Store (0x02BC, VCHP)
                    Store (0x02E5, VCXP)
                    Store (0xE6, VCYP)
                    Store (0x01E0, VCZP)
                    Store (Zero, VCKP)
                    Store (Zero, VCMP)
                    Store (Zero, VCNP)
                    Store (0x0372, VCAL)
                    Store (0x0453, VCBE)
                    Store (0x09, VCGA)
                    Store (0x64, VCPP)
                    Store (One, VCDE)
                    Return (SCPP)
                }
                Else
                {
                    If (LEqual (_T_0, 0x02))
                    {
                        Store (0x00010000, VRV2)
                        Store (0x03E8, VGWP)
                        Store (0x02EE, VGPP)
                        Store (0x02EE, VGQP)
                        Store (0x02EE, VGRP)
                        Store (One, VGAP)
                        Store (Zero, VGBP)
                        Store (Zero, VGCP)
                        Store (Zero, VGDP)
                        Store (One, VGDE)
                        Return (SGPP)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x03))
                        {
                            Store (Zero, Index (SSCP, Zero))
                            Store (Zero, CSNT)
                            Store (One, CPTI)
                            Store (0x84, CICA)
                            Store (Zero, CIRC)
                            Store (0x27FF, CICV)
                            Store (0x05, CIRA)
                            Store (0xA000, CIAV)
                            Store (0x03, CIEP)
                            Store (0x0F, CPPF)
                            Store (0x04, CSNR)
                            Store (One, Index (SSGP, Zero))
                            Store (Zero, GSNT)
                            Store (One, GPTI)
                            Store (0x8C, GICA)
                            Store (Zero, GIRC)
                            Store (0x27FF, GICV)
                            Store (0x05, GIRA)
                            Store (0xA000, GIAV)
                            Store (0x03, GIEP)
                            Store (0x0F, GPPF)
                            Store (0x04, GSNR)
                            Return (Concatenate (SSCP, SSGP))
                        }
                    }
                }
            }

            Return (0x80000002)
        }
    }

    Scope (\_SB.PCI0)
    {
        Device (WMI1)
        {
            Name (_HID, "pnp0c14")
            Name (_UID, "OPT1")
            Name (_WDG, Buffer (0x14)
            {
                /* 0000 */   0x3C, 0x5C, 0xCB, 0xF6, 0xAE, 0x9C, 0xBD, 0x4E,
                /* 0008 */   0xB5, 0x77, 0x93, 0x1E, 0xA3, 0x2A, 0x2C, 0xC0,
                /* 0010 */   0x4D, 0x58, 0x01, 0x02
            })
            Method (WMMX, 3, NotSerialized)
            {
                CreateDWordField (Arg2, Zero, FUNC)
                If (LEqual (FUNC, 0x4D53445F))
                {
                    If (LGreaterEqual (SizeOf (Arg2), 0x1C))
                    {
                        CreateField (Arg2, Zero, 0x80, MUID)
                        CreateDWordField (Arg2, 0x10, REVI)
                        CreateDWordField (Arg2, 0x14, SFNC)
                        CreateField (Arg2, 0xE0, 0x20, XRG0)
                        Return (\_SB.PCI0.GFX0._DSM (MUID, REVI, SFNC, XRG0))
                    }
                }

                Return (Zero)
            }
        }
    }
}

